#!/usr/bin/perl -w

## Copyright (c) 2004, Telecooperation Office (TecO),
## Universitaet Karlsruhe (TH), Germany.
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions
## are met:
##
##   * Redistributions of source code must retain the above copyright
##     notice, this list of conditions and the following disclaimer.
##   * Redistributions in binary form must reproduce the above
##     copyright notice, this list of conditions and the following
##     disclaimer in the documentation and/or other materials provided
##     with the distribution.
##   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
##     of its contributors may be used to endorse or promote products
##     derived from this software without specific prior written
##     permission.
##
## THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
## "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
## LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
## A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
## OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
## SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
## LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
## OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

printf <<HEREDOC;
#ifndef  SDCC_COMPAT_H
#define  SDCC_COMPAT_H

#ifdef CCS_COMPAT_H
#error You included CCS_COMPAT_H as well as SDCC_COMPAT_H, which is invalid!
#else

#define PIN(...)		__VA_ARGS__
#define INT(src)		src

HEREDOC

########################################
## provide macros to turn PORTx into TRISx or LATx

for my $i ("A","B","C","D","E","F","G","H","J") {
    printf "/* enable access to TRIS$i and LAT$i */\n";
    printf "#define TRISPORT$i TRIS$i\n";
    printf "#define LATPORT$i LAT$i\n";
    printf "#define PORTPORT$i PORT$i\n";
}
printf "\n";

printf <<HEREDOC
#endif // if only SDCC_COMPAT_H

#endif // SDCC_COMPAT_H
HEREDOC
