#!/bin/bash

PREFIX=./SDCC
TOOLPATH="`readlink -f $0`";
TOOLPATH="`dirname ${TOOLPATH}`";
CONVPL="${TOOLPATH}/convert.pl"
RENIDENT="${TOOLPATH}/bin/ren_idents"
ENUM_O_MATIC="${TOOLPATH}/bin/simple"

if [[ ! -x "${CONVPL}" ]]; then
  echo "${CONVPL} not found!";
  exit 1;
fi

if [[ ! -x "${RENIDENT}" ]]; then
  echo "${RENIDENT} not found!";
  exit 1;
fi

if [[ ! -x "${ENUM_O_MATIC}" ]]; then
  echo "${ENUM_O_MATIC} not found!";
  exit 1;
fi

rm -rf "${PREFIX}"

for i in `find . -name "*.[ch]"`; do
  FILENAME="`basename $i`";
  FILEPATH="`dirname $i`";
  DESTFILE="${PREFIX}/$i";
  
  echo "Converting $i";
  
  if [[ ! -d "${PREFIX}/${FILEPATH}" ]]; then
    mkdirhier "${PREFIX}/${FILEPATH}";
  fi
  
  cat "$i" | dos2unix | ${RENIDENT} | ${CONVPL} | ${ENUM_O_MATIC} > "${DESTFILE}"
done


for i in `find . -type f -not -name "*.[ch]"`; do
  FILENAME="`basename $i`";
  FILEPATH="`dirname $i`";
  DESTFILE="${PREFIX}/$i";
  
  echo "Copying $i";
  
  if [[ ! -d "${PREFIX}/${FILEPATH}" ]]; then
    mkdirhier "${PREFIX}/${FILEPATH}";
  fi
  
  cp "$i" "${DESTFILE}"
done    

cp ${TOOLPATH}/disptab.c "${PREFIX}";
