/**
  * Copyright (c) 2004, Telecooperation Office (TecO),
  * Universitaet Karlsruhe (TH), Germany.
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  *
  *   * Redistributions of source code must retain the above copyright
  *     notice, this list of conditions and the following disclaimer.
  *   * Redistributions in binary form must reproduce the above
  *     copyright notice, this list of conditions and the following
  *     disclaimer in the documentation and/or other materials provided
  *     with the distribution.
  *   * Neither the name of the Universitaet Karlsruhe (TH) nor the names
  *     of its contributors may be used to endorse or promote products
  *     derived from this software without specific prior written
  *     permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 **/

#ifndef INITPRIO_C
#define INITPRIO_C

void
init_irq_priorities()
{
  RCONbits.IPEN = 1;

  IPR1 =
#ifdef psp_fast
    128 +
#else
      0 +
#endif
#ifdef ad_fast
     64 +
#else 
      0 +
#endif
#ifdef rc_fast // ??
     32 +
#else 
      0 +
#endif
#ifdef tbe_fast 
     16 +
#else 
      0 +
#endif
#ifdef ssp_fast
      8 +
#else 
      0 +
#endif
#ifdef ccp1_fast
      4 +
#else 
      0 +
#endif
#ifdef timer2_fast
      2 +
#else 
      0 +
#endif
#ifdef timer1_fast
      1;
#else 
      0;
#endif



  IPR2 =
#ifdef comp_fast
     64 +
#else 
      0 +
#endif
#ifdef eeprom_fast
     16 +
#else 
      0 +
#endif
#ifdef buscol_fast
      8 +
#else 
      0 +
#endif
#ifdef lowvolt_fast
      4 +
#else 
      0 +
#endif
#ifdef timer3_fast
      2 +
#else 
      0 +
#endif
#ifdef ccp2_fast
      1;
#else 
      0;
#endif




  IPR3 =
#ifdef rc_fast // ??
     32 +
#else 
      0 +
#endif
#ifdef tbe_fast // ??
     16 +
#else 
      0 +
#endif
#ifdef timer4_fast
      8 +
#else 
      0 +
#endif
#ifdef ccp5_fast
      4 +
#else 
      0 +
#endif
#ifdef ccp4_fast
      2 +
#else 
      0 +
#endif
#ifdef ccp3_fast
      1;
#else 
      0;
#endif



_asm
#ifdef timer0_fast
     bsf _INTCON2, 2
#else 
     bcf _INTCON2, 2
#endif
#ifdef rtcc_fast
     bsf _INTCON2, 2
#else 
     bcf _INTCON2, 2
#endif
#ifdef ext3_fast
     bsf _INTCON2, 1
#else 
     bcf _INTCON2, 1      
#endif
#ifdef rb_fast
     bsf _INTCON2, 0
#else 
     bcf _INTCON2, 0
#endif
_endasm;


_asm
#ifdef ext2_fast
     bsf _INTCON3, 7
#else 
     bcf _INTCON3, 7
#endif
#ifdef ext1_fast
     bsf _INTCON3, 6
#else 
     bcf _INTCON3, 6
#endif
_endasm;

  return;
}

#endif // INITPRIO_C
